AbstractScheduledService
Date: 2016-05-24

com.google.common.util.concurrent

## Class AbstractScheduledService

- java.lang.Object
- - com.google.common.util.concurrent.AbstractScheduledService

- All Implemented Interfaces:
    Service

      @Beta
      public abstract class AbstractScheduledService
      extends java.lang.Object
      implements Service

  Base class for services that can implement `startUp()` and `shutDown()` but while in the "running" state need to perform a periodic task. Subclasses can implement `startUp()`, `shutDown()` and also a `runOneIteration()` method that will be executed periodically.

  This class uses the `ScheduledExecutorService` returned from `executor()` to run the `startUp()` and `shutDown()` methods and also uses that service to schedule the `runOneIteration()` that will be executed periodically as specified by its `AbstractScheduledService.Scheduler`. When this service is asked to stop via `stopAsync()` it will cancel the periodic task (but not interrupt it) and wait for it to stop before running the `shutDown()` method.

  Subclasses are guaranteed that the life cycle methods (`runOneIteration()`, `startUp()` and `shutDown()`) will never run concurrently. Notably, if any execution of `runOneIteration()` takes longer than its schedule defines, then subsequent executions may start late. Also, all life cycle methods are executed with a lock held, so subclasses can safely modify shared state without additional synchronization necessary for visibility to later executions of the life cycle methods.

  ### Usage Example

  Here is a sketch of a service which crawls a website and uses the scheduling capabilities to rate limit itself.

       class CrawlingService extends AbstractScheduledService {
         private Set<Uri> visited;
         private Queue<Uri> toCrawl;
         protected void startUp() throws Exception {
           toCrawl = readStartingUris();
         }

         protected void runOneIteration() throws Exception {
           Uri uri = toCrawl.remove();
           Collection<Uri> newUris = crawl(uri);
           visited.add(uri);
           for (Uri newUri : newUris) {
             if (!visited.contains(newUri)) { toCrawl.add(newUri); }
           }
         }

         protected void shutDown() throws Exception {
           saveUris(toCrawl);
         }

         protected Scheduler scheduler() {
           return Scheduler.newFixedRateSchedule(0, 1, TimeUnit.SECONDS);
         }
       }

  This class uses the life cycle methods to read in a list of starting URIs and save the set of outstanding URIs when shutting down. Also, it takes advantage of the scheduling functionality to rate limit the number of queries we perform.

  Since:
    11.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `AbstractScheduledService.CustomScheduler` A `AbstractScheduledService.Scheduler` that provides a convenient way for the `AbstractScheduledService` to use a dynamically changing schedule.
    `static class` | `AbstractScheduledService.Scheduler` A scheduler defines the policy for how the `AbstractScheduledService` should run its task.

    - ### Nested classes/interfaces inherited from interface com.google.common.util.concurrent.Service

      `Service.Listener, Service.State`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractScheduledService()` Constructor for use by subclasses.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addListener(Service.Listener listener, java.util.concurrent.Executor executor)` Registers a `Service.Listener` to be executed on the given executor.
    `void` | `awaitRunning()` Waits for the `Service` to reach the running state.
    `void` | `awaitRunning(long timeout, java.util.concurrent.TimeUnit unit)` Waits for the `Service` to reach the running state for no more than the given time.
    `void` | `awaitTerminated()` Waits for the `Service` to reach the terminated state.
    `void` | `awaitTerminated(long timeout, java.util.concurrent.TimeUnit unit)` Waits for the `Service` to reach a terminal state (either `terminated` or `failed`) for no more than the given time.
    `protected java.util.concurrent.ScheduledExecutorService` | `executor()` Returns the `ScheduledExecutorService` that will be used to execute the `startUp()`, `runOneIteration()` and `shutDown()` methods.
    `java.lang.Throwable` | `failureCause()` Returns the `Throwable` that caused this service to fail.
    `boolean` | `isRunning()` Returns `true` if this service is running.
    `protected abstract void` | `runOneIteration()` Run one iteration of the scheduled task.
    `protected abstract AbstractScheduledService.Scheduler` | `scheduler()` Returns the `AbstractScheduledService.Scheduler` object used to configure this service.
    `protected java.lang.String` | `serviceName()` Returns the name of this service.
    `protected void` | `shutDown()` Stop the service.
    `Service` | `startAsync()` If the service state is `Service.State.NEW`, this initiates service startup and returns immediately.
    `protected void` | `startUp()` Start the service.
    `Service.State` | `state()` Returns the lifecycle state of the service.
    `Service` | `stopAsync()` If the service is starting or running, this initiates service shutdown and returns immediately.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractScheduledService

          protected AbstractScheduledService()

      Constructor for use by subclasses.

  - ### Method Detail

    - #### runOneIteration

          protected abstract void runOneIteration()
                                           throws java.lang.Exception

      Run one iteration of the scheduled task. If any invocation of this method throws an exception, the service will transition to the `Service.State.FAILED` state and this method will no longer be called.
      Throws:
        `java.lang.Exception`

    - #### startUp

          protected void startUp()
                          throws java.lang.Exception

      Start the service.

      By default this method does nothing.

      Throws:
        `java.lang.Exception`

    - #### shutDown

          protected void shutDown()
                           throws java.lang.Exception

      Stop the service. This is guaranteed not to run concurrently with `runOneIteration()`.

      By default this method does nothing.

      Throws:
        `java.lang.Exception`

    - #### scheduler

          protected abstract AbstractScheduledService.Scheduler scheduler()

      Returns the `AbstractScheduledService.Scheduler` object used to configure this service. This method will only be called once.

    - #### executor

          protected java.util.concurrent.ScheduledExecutorService executor()

      Returns the `ScheduledExecutorService` that will be used to execute the `startUp()`, `runOneIteration()` and `shutDown()` methods. If this method is overridden the executor will not be shutdown when this service terminates or fails. Subclasses may override this method to supply a custom `ScheduledExecutorService` instance. This method is guaranteed to only be called once.

      By default this returns a new `ScheduledExecutorService` with a single thread thread pool that sets the name of the thread to the service name. Also, the pool will be shut down when the service terminates or fails.

    - #### serviceName

          protected java.lang.String serviceName()

      Returns the name of this service. `AbstractScheduledService` may include the name in debugging output.
      Since:
        14.0

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### isRunning

          public final boolean isRunning()

      Description copied from interface: `Service`
      Returns `true` if this service is running.
      Specified by:
        `isRunning` in interface `Service`

    - #### state

          public final Service.State state()

      Description copied from interface: `Service`
      Returns the lifecycle state of the service.
      Specified by:
        `state` in interface `Service`

    - #### addListener

          public final void addListener(Service.Listener listener,
                         java.util.concurrent.Executor executor)

      Description copied from interface: `Service`
      Registers a `Service.Listener` to be executed on the given executor. The listener will have the corresponding transition method called whenever the service changes state. The listener will not have previous state changes replayed, so it is suggested that listeners are added before the service starts.

      `addListener` guarantees execution ordering across calls to a given listener but not across calls to multiple listeners. Specifically, a given listener will have its callbacks invoked in the same order as the underlying service enters those states. Additionally, at most one of the listener's callbacks will execute at once. However, multiple listeners' callbacks may execute concurrently, and listeners may execute in an order different from the one in which they were registered.

      RuntimeExceptions thrown by a listener will be caught and logged. Any exception thrown during `Executor.execute` (e.g., a `RejectedExecutionException`) will be caught and logged.

      Specified by:
        `addListener` in interface `Service`
      Parameters:
        `listener` - the listener to run when the service changes state is complete
        `executor` - the executor in which the listeners callback methods will be run. For fast, lightweight listeners that would be safe to execute in any thread, consider `MoreExecutors.directExecutor()`.
      Since:
        13.0

    - #### failureCause

          public final java.lang.Throwable failureCause()

      Description copied from interface: `Service`
      Returns the `Throwable` that caused this service to fail.
      Specified by:
        `failureCause` in interface `Service`
      Since:
        14.0

    - #### startAsync

          public final Service startAsync()

      Description copied from interface: `Service`
      If the service state is `Service.State.NEW`, this initiates service startup and returns immediately. A stopped service may not be restarted.
      Specified by:
        `startAsync` in interface `Service`
      Returns:
        this
      Since:
        15.0

    - #### stopAsync

          public final Service stopAsync()

      Description copied from interface: `Service`
      If the service is starting or running, this initiates service shutdown and returns immediately. If the service is new, it is terminated without having been started nor stopped. If the service has already been stopped, this method returns immediately without taking action.
      Specified by:
        `stopAsync` in interface `Service`
      Returns:
        this
      Since:
        15.0

    - #### awaitRunning

          public final void awaitRunning()

      Description copied from interface: `Service`
      Waits for the `Service` to reach the running state.
      Specified by:
        `awaitRunning` in interface `Service`
      Since:
        15.0

    - #### awaitRunning

          public final void awaitRunning(long timeout,
                          java.util.concurrent.TimeUnit unit)
                                  throws java.util.concurrent.TimeoutException

      Description copied from interface: `Service`
      Waits for the `Service` to reach the running state for no more than the given time.
      Specified by:
        `awaitRunning` in interface `Service`
      Parameters:
        `timeout` - the maximum time to wait
        `unit` - the time unit of the timeout argument
      Throws:
        `java.util.concurrent.TimeoutException` - if the service has not reached the given state within the deadline
      Since:
        15.0

    - #### awaitTerminated

          public final void awaitTerminated()

      Description copied from interface: `Service`
      Waits for the `Service` to reach the terminated state.
      Specified by:
        `awaitTerminated` in interface `Service`
      Since:
        15.0

    - #### awaitTerminated

          public final void awaitTerminated(long timeout,
                             java.util.concurrent.TimeUnit unit)
                                     throws java.util.concurrent.TimeoutException

      Description copied from interface: `Service`
      Waits for the `Service` to reach a terminal state (either `terminated` or `failed`) for no more than the given time.
      Specified by:
        `awaitTerminated` in interface `Service`
      Parameters:
        `timeout` - the maximum time to wait
        `unit` - the time unit of the timeout argument
      Throws:
        `java.util.concurrent.TimeoutException` - if the service has not reached the given state within the deadline
      Since:
        15.0